unit hiGL_Color;

interface

uses Kol,Share,Debug,OpenGL;

type
  THIGL_Color = class(TDebug)
   private
   public
    _prop_Color:TColor;
    _prop_Alpha:real;
    _prop_mRed:boolean;
    _prop_mGreen:boolean;
    _prop_mBlue:boolean;
    _prop_mAlpha:boolean;

    _data_Color:THI_Event;
    _data_Alpha:THI_Event;
    _event_onColor:THI_Event;
    _event_onMask:THI_Event;

    procedure _work_doColor(var _Data:TData; Index:word);
    procedure _work_doMask(var _Data:TData; Index:word);
  end;

implementation

uses hiGL_Main;

procedure THIGL_Color._work_doColor;
var
  c:TColor;
  a:real;
begin
    c := ReadInteger(_data,_data_Color,_prop_Color);
    a := ReadReal(_data,_data_Alpha,_prop_Alpha);
    if a = 1.0 then
     glColor(c)
    else glColora(c,a);
    _hi_CreateEvent(_Data,@_event_onColor);
end;

procedure THIGL_Color._work_doMask;
begin
    glColorMask(_prop_mRed, _prop_mGreen, _prop_mBlue, _prop_mAlpha);
    _hi_CreateEvent(_Data,@_event_onMask);
end;

end.
